#include <pthread.h>
#include <rtai.h>
#include <rtai_fifos.h>

void *thread1( void* arg )
{
	int count = 0;
	void* result = NULL;

	RT_TASK* task1 = rt_task_init_schmod(nam2num("THRED1"), 3, 1024, 1024, SCHED_FIFO, 1 );
	if( task1 )
	{
		printf("task1 start\n");
		rt_make_hard_real_time();

		int fid = open( "/dev/rtf0", O_RDWR );
		rtf_sem_wait( fid /* semaphore */ );
		rt_task_delete( task1 );
		printf("task1 end\n");
	}
	else
	{
		printf("Failed to create task1\n");
	}
	return( result );
}

void* thread2( void* arg )
{
	int count = 0;
	void* result = NULL;

	RT_TASK* task2 = rt_task_init_schmod(nam2num("THRED2"), 2 , 1024, 1024, SCHED_FIFO, 1 );
	if( task2 )
	{
		printf("Task2 start\n");
		rt_make_hard_real_time();

		int fid = open( "/dev/rtf0", O_RDWR );
		rtf_sem_post( fid /* semaphore */ );

		rt_task_delete( task2 );
		printf("task2 end\n");
	}
	else
	{
		printf("Failed to create task2\n");
	}
	return( result );
}

main()
{
	pthread_t th1, th2;

	rt_allow_nonroot_hrt();

	RT_TASK* mainTask = rt_task_init_schmod(nam2num("MAIN"), 10, 1024, 1024, SCHED_FIFO, 1 );
	if( NULL == mainTask )
	{
		printf("Failed to create main task.\n");
		return( 0 );
	}
	
	/* Initialize semaphore */
	int fid = open("/dev/rtf0", O_RDWR );
	rtf_sem_init(	fid /* semaphore */,
					0 /* initial value. 0 or 1 */ );

	pthread_create( &th1, NULL, thread1, NULL );
	sleep(2);
	pthread_create( &th2, NULL, thread2, NULL );

	pthread_join( th1, NULL );
	pthread_join( th2, NULL );

	rt_task_delete( mainTask );
}

